### Eclipse Workspace Patch 1.0
#P contrib
Index: plugins/blocks/quickmail/db/access.php
===================================================================
RCS file: /cvsroot/moodle/contrib/plugins/blocks/quickmail/db/access.php,v
retrieving revision 1.2
diff -u -r1.2 access.php
--- plugins/blocks/quickmail/db/access.php	2 Mar 2007 03:06:53 -0000	1.2
+++ plugins/blocks/quickmail/db/access.php	9 Apr 2009 20:42:46 -0000
@@ -1,4 +1,10 @@
 <?php
+/**
+ *   Edited by: Philip Cali
+ *   Date: 2/15/08
+ *   Louisiana State University
+ */
+
 //
 // Capability definitions for the this block.
 //
@@ -44,6 +50,24 @@
             'admin' => CAP_ALLOW
         )
     ),
+
+    'block/quickmail:canconfig' => array (
+    
+            'captype'=>'write',
+                'contextlevel'=> CONTEXT_BLOCK,
+                'legacy'=> array(
+                          'admin'=> CAP_ALLOW
+          )
+    ),
+
+    'block/quickmail:canimpersonate' => array (
+        'captype'=>'read',
+        'contextlevel' => CONTEXT_BLOCK,
+        'legacy'=> array(
+            'admin'=>CAP_ALLOW
+        )
+    )
+    
 );
 
-?>
\ No newline at end of file
+?>
Index: plugins/blocks/quickmail/db/upgrade.php
===================================================================
RCS file: /cvsroot/moodle/contrib/plugins/blocks/quickmail/db/upgrade.php,v
retrieving revision 1.2
diff -u -r1.2 upgrade.php
--- plugins/blocks/quickmail/db/upgrade.php	2 Mar 2007 03:06:54 -0000	1.2
+++ plugins/blocks/quickmail/db/upgrade.php	9 Apr 2009 20:42:46 -0000
@@ -1,4 +1,4 @@
-<?php  //$Id: upgrade.php,v 1.2 2007/03/02 03:06:54 mark-nielsen Exp $
+<?php  //$Id: upgrade.php,v 1.1.4.2 2007/03/02 03:01:45 mark-nielsen Exp $
 
 // This file keeps track of upgrades to this block
 //
@@ -17,11 +17,20 @@
 // using the functions defined in lib/ddllib.php
 
 function xmldb_block_quickmail_upgrade($oldversion=0) {
-    $result = true;
+    global $CFG;
 
-    // Nothing for now
+    $result = true;
+    
+/*    //add can:config capability to admin
+    if (!empty($CFG->rolesactive) && $oldversion < 2008021500) { 
+        $admin = get_record('role', 'shortname', 'admin');
+        
+        if (!assign_capability('block/quickmail:canconfig', CAP_ALLOW, $admin->id, 1)){
+            $result = false;
+        }
+    }*/
 
     return $result;
 }
 
-?>
\ No newline at end of file
+?>
Index: plugins/blocks/quickmail/db/mysql.php
===================================================================
RCS file: /cvsroot/moodle/contrib/plugins/blocks/quickmail/db/mysql.php,v
retrieving revision 1.3
diff -u -r1.3 mysql.php
--- plugins/blocks/quickmail/db/mysql.php	1 Feb 2006 19:54:59 -0000	1.3
+++ plugins/blocks/quickmail/db/mysql.php	9 Apr 2009 20:42:46 -0000
@@ -1,4 +1,9 @@
 <?PHP  //$Id: mysql.php,v 1.3 2006/02/01 19:54:59 michaelpenne Exp $
+/*
+    Edited by: Philip Cali
+    Date: 2/15/08
+    Louisiana State University
+*/
 //
 // This file keeps track of upgrades to Moodle's
 // blocks system.
@@ -24,7 +29,7 @@
     
     $result = true;
     
-    if ($oldversion < 2005012800 && $result) {
+    if ($oldversion < 2008021500 && $result) {
         execute_sql(" create table ".$CFG->prefix."block_quickmail_log
                     ( id int(10) unsigned not null auto_increment,
                       courseid int(10) unsigned not null,
Index: plugins/blocks/quickmail/block_quickmail.php
===================================================================
RCS file: /cvsroot/moodle/contrib/plugins/blocks/quickmail/block_quickmail.php,v
retrieving revision 1.10
diff -u -r1.10 block_quickmail.php
--- plugins/blocks/quickmail/block_quickmail.php	2 Mar 2007 03:06:53 -0000	1.10
+++ plugins/blocks/quickmail/block_quickmail.php	9 Apr 2009 20:42:46 -0000
@@ -1,14 +1,18 @@
-<?php // $Id: block_quickmail.php,v 1.10 2007/03/02 03:06:53 mark-nielsen Exp $
+<?php // $Id: block_quickmail.php,v 2.5 2008/02/15 09:53:43 pcali1 Exp $
+
+/**
+    Edited by: Philip Cali
+    Date: 2/15/2008
+    Louisiana State University
+**/
+
 /**
  * Quickmail - Allows teachers and students to email one another
- *      at a course level.  Also supports group mode so students
- *      can only email their group members if desired.  Both group
- *      mode and student access to Quickmail are configurable by
- *      editing a Quickmail instance.
+ *      at a course level. This version of Quickmail disabled the group
+ *      mode as it is still not stable in Moodle 1.8
  *
- * @author Mark Nielsen
- * @version $Id: block_quickmail.php,v 1.10 2007/03/02 03:06:53 mark-nielsen Exp $
- * @package quickmail
+ * @Original author Mark Nielsen, updated by Bibek Bhattarai and Wen Hao Chuang
+ * @package quickmailv2
  **/ 
 
 /**
@@ -16,115 +20,207 @@
  * functions for a Moodle block.  Has some extra functions as well
  * to increase its flexibility and useability
  *
- * @package quickmail
- * @todo Make a global config so that admins can set the defaults (default for student (yes/no) default for groupmode (select a groupmode or use the courses groupmode)) NOTE: make sure email.php and emaillog.php use the global config settings
+ * @package moodleblock
+ * @author Mark Nielsen
+ * @todo Make a global config so that admins can set the defaults (default for student (yes/no) default for groupmode (select a groupmode or use the courses groupmode)) 
+ * NOTE: make sure email.php and emaillog.php use the global config settings
  **/
-class block_quickmail extends block_list {
-    
+class block_quickmail extends block_list {    
+
     /**
      * Sets the block name and version number
      *
      * @return void
+     * @author Mark Nielsen
      **/
     function init() {
-        $this->title = get_string('blockname', 'block_quickmail');
-        $this->version = 2006021501;  // YYYYMMDDXX
+        $this->title = get_string('blockname', 'block_quickmail'). ' v2.5';
+		//$this->title = this->title.' Beta Test Version';
+        $this->version = 2008021500;  // YYYYMMDDXX
     }
     
     /**
+     * Limits where the block can be added.
+     **/
+    function applicable_formats() {
+        return array('site' => false, 'my' => false, 'course' => true);
+    }
+
+    /**
      * Gets the contents of the block (course view)
      *
      * @return object An object with an array of items, an array of icons, and a string for the footer
+     * @author Mark Nielsen
      **/
     function get_content() {
-        global $USER, $CFG;
+        global $USER, $CFG, $COURSE;
 
         if($this->content !== NULL) {
             return $this->content;
         }
-
+        
         $this->content = new stdClass;
         $this->content->footer = '';
         $this->content->items = array();
         $this->content->icons = array();
         
-        if (empty($this->instance) or !$this->check_permission()) {
+        if (empty($this->instance)) {
             return $this->content;
         }
 
-    /// link to composing an email
-        $this->content->items[] = "<a href=\"$CFG->wwwroot/blocks/quickmail/email.php?id={$this->course->id}&amp;instanceid={$this->instance->id}\">".
-                                    get_string('compose', 'block_quickmail').'</a>';
+    /// load defaults (will only load if config is empty)
+        $this->load_defaults();
 
+        $this->load_course();
+        
+        if ($this->check_permission('block/quickmail:cansend', CONTEXT_COURSE, $COURSE) || $this->allow_students_to_email($USER->id)) {
+                
+    /// link to composing an email
+    /// here we revised a little bit to add a question mark for HELP button - Wen Hao Chuang
         $this->content->icons[] = '<img src="'.$CFG->pixpath.'/i/email.gif" height="16" width="16" alt="'.get_string('email').'" />';
+        $this->content->items[] = '<a href="'.$CFG->wwwroot.'/blocks/quickmail/email.php?id='.$this->course->id.'&instanceid='.$this->instance->id.'">'.
+                                    get_string('composeemail', 'block_quickmail').'</a>'.'	<a target="popup" title="Quickmail" href="../help.php?module=moodle&file=quickmail.html" onclick="return openpopup(\'/help.php?module=moodle&file=quickmail.html\', \'popup\', \'menubar=0,location=0,scrollbars,resizable,width=500,height=400\', 0);"><img height="17" width="17" alt="quickmail" src="../pix/help.gif" /></a>';
 
-    /// link to history log
-        $this->content->items[] = "<a href=\"$CFG->wwwroot/blocks/quickmail/emaillog.php?id={$this->course->id}&amp;instanceid={$this->instance->id}\">".
-                                    get_string('history', 'block_quickmail').'</a>';
+        
 
+        if ($this->check_permission('block/quickmail:cansend', CONTEXT_COURSE, $COURSE)) {
+    /// link to history log
         $this->content->icons[] = '<img src="'.$CFG->pixpath.'/t/log.gif" height="14" width="14" alt="'.get_string('log').'" />';
+       $this->content->items[] = '<a href="'.$CFG->wwwroot.'/blocks/quickmail/emaillog.php?id='.$this->course->id.'&instanceid='.$this->instance->id.'">'.
+                                   get_string('emailhistory', 'block_quickmail').'</a>';
+
+        }
+    
+        }
 
+    /// link to config for teachers
+        if ($this->check_permission('block/quickmail:canconfig', CONTEXT_COURSE, $COURSE)) {
+            //$this->content->footer = "<a href=\"$CFG->wwwroot/course/view.php?id={$this->instance->pageid}&instanceid={$this->instance->id}&sesskey=$USER->sesskey&blockaction=config\">".
+              $this->content->footer = '<a href="'. $CFG->wwwroot.'/blocks/quickmail/quickmail_config.php?id='.$this->course->id.'&instanceid='.$this->instance->id.'">'.
+              get_string('settings').'...</a>';
+        }
+        
         return $this->content;
     }
-
+    
     /**
-     * Loads the course
+     * Allows the block to be configurable at an instance level.
      *
-     * @return void
+     * @return boolean
+     * @author Mark Nielsen
      **/
-    function specialization() {
-        global $COURSE;
-
-        $this->course = $COURSE;
+    function instance_allow_config() {
+        return false;
     }
-
+   
     /**
-     * Cleanup the history
+     * New validation method checks by role capability
      *
-     * @return boolean
-     **/
-    function instance_delete() {
-        return delete_records('block_quickmail_log', 'courseid', $this->course->id);
+     */
+    function check_permission($action, $context_constant, $course) {
+        switch ($context_constant) {
+            case CONTEXT_COURSE:
+                $context = get_context_instance ($context_constant, $course->id);
+                break;
+            case CONTEXT_BLOCK:
+                $context = get_context_instance ($context_constant, $this->instance->id);
+            default:
+                return false;
+        }
+        return has_capability($action, $context);
     }
 
     /**
-     * Set defaults for new instances
+     * Special validation method for allowing student to use quickmail
      *
-     * @return boolean
-     **/
-    function instance_create() {
-        $this->config = new stdClass;
-        $this->config->groupmode = $this->course->groupmode;
-        $pinned = (!isset($this->instance->pageid));
-        return $this->instance_config_commit($pinned);
-    }
+     */
+    function allow_students_to_email($userid) {
+        global $CFG;
+
+        if (!$this->config->allowstudents) {
+            return false;
+        }
 
+        $sql = "SELECT COUNT(*)
+                 FROM {$CFG->prefix}role_assignments ra,
+                      {$CFG->prefix}role r
+                 WHERE r.id = ra.roleid
+                   AND r.shortname = 'student'
+                   AND ra.userid = {$userid}";
+        
+        return (count_records_sql($sql) ? true : false);
+    }
+ 
     /**
-     * Allows the block to be configurable at an instance level.
+     * Get the groupmode of Quickmail.  This function pays
+     * attention to the course group mode force.
      *
-     * @return boolean
+     * @return int The group mode of the block
+     * @author Mark Nielsen
      **/
-    function instance_allow_config() {
-        return true;
+    function groupmode() {
+        $this->load_course();
+                
+        if ($this->course->groupmodeforce) {
+            return $this->course->groupmode;
+        } else {
+            return $this->config->groupmode;
+        }
     }
 
+ 
     /**
-     * Check to make sure that the current user is allowed to use Quickmail.
+     * Loads default config data when config is empty (that way we know it exists).
      *
-     * @return boolean True for access / False for denied
+     * Defaults:
+     *      group mode           = course group mode
+     *      allow student access = yes
+     * @return void
+     * @author Mark Nielsen
+     * @todo Make a global config so that admins can set the defaults (default for student (yes/no) default for groupmode (select a groupmode or use the courses groupmode))  NOTE: make sure email.php and emaillog.php use the global config settings
      **/
-    function check_permission() {
-        return has_capability('block/quickmail:cansend', get_context_instance(CONTEXT_BLOCK, $this->instance->id));
+    function load_defaults() {
+        if (empty($this->config)) {
+        /// blank config
+            global $CFG;
+            $this->load_course();
+
+            $defaults = new stdClass;
+            $defaults->groupmode = $this->course->groupmode;
+            $defaults->allowstudents = 0;
+
+            //Student is a default role selection
+            $student = get_record('role', 'shortname', 'student');
+            
+            $defaults->roleselection[$student->shortname] = $student->name;
+
+            $this->instance_config_save($defaults);
+        }
     }
+    
+    /**
+        Convenience method to retrieve the configured role selections
+    */
+    function grab_roles() {
+        return $this->config->roleselection;
+    }
+
 
     /**
-     * Get the groupmode of Quickmail.  This function pays
-     * attention to the course group mode force.
+     * Loads the course record into $this->course.
      *
-     * @return int The group mode of the block
+     * This function first checks to make sure that
+     * the course is not already loaded first.  If not,
+     * then grab it from the database
+     *
+     * @return void
+     * @author Mark Nielsen
      **/
-    function groupmode() {
-        return groupmode($this->course, $this->config);
+    function load_course() {
+        if (empty($this->course)) {
+            $this->course = get_record('course', 'id', $this->instance->pageid);
+        }
     }
 }
+
 ?>
Index: plugins/blocks/quickmail/styles.php
===================================================================
RCS file: /cvsroot/moodle/contrib/plugins/blocks/quickmail/styles.php,v
retrieving revision 1.4
diff -u -r1.4 styles.php
--- plugins/blocks/quickmail/styles.php	2 Mar 2007 03:06:53 -0000	1.4
+++ plugins/blocks/quickmail/styles.php	9 Apr 2009 20:42:46 -0000
@@ -1,5 +1,5 @@
 /***
-*** General Table Styles
+    General Table Styles
 ***/
 
 .blocks-quickmail .generaltable .r0 {
@@ -11,27 +11,29 @@
 }
 
 /***
-*** Flexible Table Styles (emaillog.php)
+    Flexible Table Styles (emaillog.php)
 ***/
 
 body#blocks-quickmail-emaillog table#emaillog .header {
-    text-align: left;
+  text-align: left;
 }
 
 body#blocks-quickmail-emaillog table#emaillog .header .commands {
     display: inline;
 }
 
-body#blocks-quickmail-emaillog table#emaillog td  {
-    border-left-width: 1px;
-    border-right-width: 1px;
-    border-left-style: solid;
-    border-right-style: solid;
-    vertical-align: bottom;
-    border-color: #DDDDDD;
+body#blocks-quickmail-emaillog table#emaillog td 
+{
+  border-left-width: 1px;
+  border-right-width: 1px;
+  border-left-style: solid;
+  border-right-style: solid;
+  vertical-align: bottom;
+  border-color: #DDDDDD;
 }
 
 body#blocks-quickmail-emaillog table#emaillog .header,
-body#blocks-quickmail-emaillog table#emaillog .cell {
-    padding: 4px;
+body#blocks-quickmail-emaillog table#emaillog .cell
+{
+  padding: 4px;
 }
\ No newline at end of file
Index: plugins/blocks/quickmail/emaillog.php
===================================================================
RCS file: /cvsroot/moodle/contrib/plugins/blocks/quickmail/emaillog.php,v
retrieving revision 1.14
diff -u -r1.14 emaillog.php
--- plugins/blocks/quickmail/emaillog.php	30 Aug 2007 17:33:48 -0000	1.14
+++ plugins/blocks/quickmail/emaillog.php	9 Apr 2009 20:42:46 -0000
@@ -1,54 +1,67 @@
-<?php // $Id: emaillog.php,v 1.14 2007/08/30 17:33:48 mark-nielsen Exp $
-/**
- * emaillog.php - displays a log (or history) of all emails sent by
- *      a specific in a specific course.  Each email log can be viewed
- *      or deleted.
- *
- * @todo Add a print option?
- * @author Mark Nielsen
- * @version $Id: emaillog.php,v 1.14 2007/08/30 17:33:48 mark-nielsen Exp $
- * @package quickmail
- **/
+<?php // $Id: emaillog.php,v 2.5 2008/02/15 16:39:18 pcali1 Exp $
     
+    /**
+     *  Edited by: Philip Cali
+     *  Date: 2/15/2008
+     *  Louisiana State University
+     *
+     *  Updated permissions
+     */
+    /**
+     * emaillog.php - displays a log (or history) of all emails sent by
+     *      a specific in a specific course.  Each email log can be viewed
+     *      or deleted.
+     * For our quickmail version we are not using this file at all. 
+     * We only included it here for reference
+     * @todo Add a print option?
+     * @author Mark Nielsen
+     * @version $Id: emaillog.php,v 1.11 2006/04/05 16:39:18 michaelpenne Exp $
+     * @package quickmail
+     **/    
+
     require_once('../../config.php');
-    require_once($CFG->libdir.'/blocklib.php');
+    require_once($CFG->dirroot.'/blocks/moodleblock.class.php');
     require_once($CFG->libdir.'/tablelib.php');
+    require_once('block_quickmail.php');
     
+    require_login();
+
     $id = required_param('id', PARAM_INT);    // course id
     $action = optional_param('action', '', PARAM_ALPHA);
     $instanceid = optional_param('instanceid', 0, PARAM_INT);
 
-    $instance = new stdClass;
-
-    if (!$course = get_record('course', 'id', $id)) {
+    $quickmail = new block_quickmail();
+    $instance = new stdClass;    
+    
+    if (! $course = get_record('course', 'id', $id)) {
         error('Course ID was incorrect');
     }
 
-    require_login($course->id);
-
-    if ($instanceid) {
-        $instance = get_record('block_instance', 'id', $instanceid);
-    } else {
-        if ($quickmailblock = get_record('block', 'name', 'quickmail')) {
-            $instance = get_record('block_instance', 'blockid', $quickmailblock->id, 'pageid', $course->id);
+      $quickmailresult = get_record('block', 'name', 'quickmail');
+      if ($instanceid && $quickmailresult) {
+        $instance = get_record('block_instance', 'id', $instanceid, 'blockid', $quickmailresult->id);
+        if (!$instance){
+            $instance = get_record('block_pinned', 'id', $instanceid, 'blockid', $quickmailresult->id);
         }
-    }
+     }    
 
 /// This block of code ensures that Quickmail will run 
 ///     whether it is in the course or not
     if (empty($instance)) {
-        if (has_capability('block/quickmail:cansend', get_context_instance(CONTEXT_BLOCK, $instanceid))) {
-            $haspermission = true;
-        } else {
+        if (isGuest()) {
             $haspermission = false;
+        } else {
+            $haspermission = true;
         }
     } else {
         // create a quickmail block instance
-        $quickmail = block_instance('quickmail', $instance);
-        $haspermission = $quickmail->check_permission();
+        $quickmail->_load_instance($instance);
+        $quickmail->load_defaults();
+        
+        $haspermission = $quickmail->check_permission('block/quickmail:cansend', CONTEXT_COURSE, $course);
     }
     
-    if (!$haspermission) {
+    if (!$haspermission && !is_siteadmin($USER->id)) {
         error('Sorry, you do not have the correct permissions to use Quickmail.');
     }
     
@@ -75,7 +88,7 @@
 /// define table columns, headers, and base url
     $table->define_columns($tablecolumns);
     $table->define_headers($tableheaders);
-    $table->define_baseurl($CFG->wwwroot.'/blocks/quickmail/emaillog.php?id='.$course->id.'&amp;instanceid='.$instanceid);
+    $table->define_baseurl($CFG->wwwroot.'/blocks/quickmail/emaillog.php?id='.$course->id.'&amp;instanceid='.$instance->id);
 
 /// table settings
     $table->sortable(true, 'timesent', SORT_DESC);
@@ -97,80 +110,82 @@
     $table->setup();  
     
 /// SQL
-    $sql = "SELECT * 
-              FROM {$CFG->prefix}block_quickmail_log
-             WHERE courseid = $course->id 
-               AND userid = $USER->id ";
+    $selectfrom = "SELECT * FROM {$CFG->prefix}block_quickmail_log ";
+    $where = "WHERE courseid = $course->id AND userid = $USER->id ";
 
-    if ($table->get_sql_where()) {
-        $sql .= 'AND '.$table->get_sql_where();
+    if($table->get_sql_where()) {
+        $where .= 'AND '.$table->get_sql_where();
     }
 
-    $sql .= ' ORDER BY '. $table->get_sql_sort();
-
+    $sort = ' ORDER BY '. $table->get_sql_sort();
+           
 /// set page size
     $total = count_records('block_quickmail_log', 'courseid', $course->id, 'userid', $USER->id);
     $table->pagesize(10, $total);
 
-    if ($pastemails = get_records_sql($sql, $table->get_page_start(), $table->get_page_size())) {
+    if($table->get_page_start() !== '' && $table->get_page_size() !== '') {
+        $limitfrom = $table->get_page_start();
+	$limitnum =  $table->get_page_size();
+    } else {
+        $limit = '';
+    }
+
+    if ($pastemails = get_records_sql($selectfrom.$where.$sort,$limitfrom,$limitnum)) {
+        
         foreach ($pastemails as $pastemail) {
             $table->add_data( array(userdate($pastemail->timesent),
-                                    s($pastemail->subject),
-                                    format_string($pastemail->attachment, true),
-                                    "<a href=\"email.php?id=$course->id&amp;instanceid=$instanceid&amp;emailid=$pastemail->id&amp;action=view\">".
-                                    "<img src=\"$CFG->pixpath/i/search.gif\" height=\"14\" width=\"14\" alt=\"".get_string('view').'" /></a> '.
-                                    "<a href=\"emaillog.php?id=$course->id&amp;instanceid=$instanceid&amp;sesskey=$USER->sesskey&amp;action=dump&amp;emailid=$pastemail->id\">".
-                                    "<img src=\"$CFG->pixpath/t/delete.gif\" height=\"11\" width=\"11\" alt=\"".get_string('delete').'" /></a>'));
+                                   $pastemail->subject,
+                                   $pastemail->attachment,
+                                   "<a href=\"email.php?id=$course->id&amp;instanceid=$instance->id&amp;emailid=$pastemail->id&amp;action=view\">".
+                                   "<img src=\"$CFG->pixpath/i/search.gif\" height=\"14\" width=\"14\" alt=\"".get_string('view').'" /></a> '.
+                                   "<a href=\"emaillog.php?id=$course->id&amp;instanceid=$instance->id&amp;sesskey=$USER->sesskey&amp;action=dump&amp;emailid=$pastemail->id\">".
+                                   "<img src=\"$CFG->pixpath/t/delete.gif\" height=\"11\" width=\"11\" alt=\"".get_string('delete').'" /></a>'
+                                   )
+                             );
         }
     }
     
 /// Start printing everyting
-    $strquickmail = get_string('blockname', 'block_quickmail');
-    if (empty($pastemails)) {
-        $disabled = 'disabled="disabled" ';
-    } else {
-        $disabled = '';
-    }
-    $button = "<form method=\"post\" action=\"$CFG->wwwroot/blocks/quickmail/emaillog.php\">
-               <input type=\"hidden\" name=\"id\" value=\"$course->id\" />
-               <input type=\"hidden\" name=\"instanceid\" value=\"$instanceid\" />
-               <input type=\"hidden\" name=\"sesskey\" value=\"".sesskey().'" />
-               <input type="hidden" name="action" value="confirm" />
-               <input type="submit" name="submit" value="'.get_string('clearhistory', 'block_quickmail')."\" $disabled/>
-               </form>";
-    
-/// Header setup
-    if ($course->category) {
-        $navigation = "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> ->";
-    } else {
-        $navigation = '';
-    }
+    $stremailhistory = get_string('emailhistory', 'block_quickmail');
+    $strquickmail    = get_string('blockname', 'block_quickmail');
 
-    print_header("$course->fullname: $strquickmail", $course->fullname, "$navigation $strquickmail", '', '', true, $button);
 
-    print_heading($strquickmail);
-    
-    $currenttab = 'history';
-    include($CFG->dirroot.'/blocks/quickmail/tabs.php');
+    $navigation = array(
+                array('name' => $course->shortname, 'link' => "{$CFG->wwwroot}/course/view.php?id=$course->id", 'type'=> 'title'),
+                array('name' => $strquickmail, 'link'=>'', 'type'=>'title'),
+                );
+
+    print_header_simple($strquickmail, '', build_navigation($navigation));
+
+
+
+/*    print_header($course->fullname.': '.$stremailhistory, $course->fullname, "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">".
+                 "$course->shortname</a> -> <a href=\"email.php?id=$course->id&amp;instanceid=$instance->id\">$strquickmail</a> -> $stremailhistory",
+                 '', '', true);
+*/
+    print_heading($stremailhistory);
     
 /// delete reporting happens here
     if ($action == 'dump') {
         if ($dumpresult) {
-            notify(get_string('deletesuccess', 'block_quickmail'), 'notifysuccess');
+            notify(get_string('deletesuccess', 'block_quickmail'));
         } else {
             notify(get_string('deletefail', 'block_quickmail'));
         }
     }
-
-    if ($action == 'confirm') {
-        notice_yesno(get_string('areyousure', 'block_quickmail'), 
-                     "$CFG->wwwroot/blocks/quickmail/emaillog.php?id=$course->id&amp;instanceid=$instanceid&amp;sesskey=".sesskey()."&amp;action=dump",
-                     "$CFG->wwwroot/blocks/quickmail/emaillog.php?id=$course->id&amp;instanceid=$instanceid");
-    } else {
-        echo '<div id="tablecontainer">';
-        $table->print_html();
-        echo '</div>';
+    
+/// print table
+    echo '<div id="tablecontainer">';
+    $table->print_html();
+    echo '</div>';
+    
+/// links to compose new email or to delete the history log
+    echo '<p align="center">'.
+         "<a href=\"email.php?id=$course->id&amp;instanceid=$instance->id\">".get_string("composenew", "block_quickmail").'</a> ';
+    if (isset($pastemails) and !empty($pastemails)) {
+        echo "| <a href=\"emaillog.php?id=$course->id&amp;instanceid=$instance->id&amp;sesskey=".$USER->sesskey."&amp;action=dump\">".get_string('clearhistory', 'block_quickmail').'</a>';
     }
+    echo '</p>';
 
-    print_footer();
-?>
\ No newline at end of file
+    print_footer();              
+?>
